IdentityServer/Controllers/AdministrationController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using IdentityServer.Models;
using IdentityServer.ViewModels;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace IdentityServer.Controllers
{
    [Authorize(Roles = "Administrator")]
    public class AdministrationController : Controller
    {
        private readonly RoleManager<IdentityRole> roleManager;
        private readonly UserManager<ApplicationUser> userManager;

        public AdministrationController(RoleManager<IdentityRole> roleManager, UserManager<ApplicationUser> userManager)
        {
            this.roleManager = roleManager;
            this.userManager = userManager;
        }
        public IActionResult CreateRole()
        {
            return View();
        }
        [HttpPost]
        public async Task<IActionResult> CreateRole(CreateRoleVM model)
        {
            if (ModelState.IsValid)
            {
                var role = new IdentityRole() { Name = model.RoleName };
                var result = await roleManager.CreateAsync(role);

                if (result.Succeeded)
                {
                    return RedirectToAction("Roles");
                }
                foreach (var error in result.Errors)
                {
                    ModelState.AddModelError("",error.Description);
                }
            }
            return View(model);
        }

        public async Task<IActionResult> Roles()
        {
            var roles = await roleManager.Roles.ToListAsync();
            return View(roles);
        }

        public async Task<IActionResult> UpdateRole(string id)
        {
            var role = await roleManager.FindByIdAsync(id);
            if(role != null)
            {
                var users = await userManager.GetUsersInRoleAsync(role.Name);
                var roleToEdit = new UpdateRoleVM() { RoleID = role.Id, RoleName = role.Name, Users = users.Select(x=> new ApplicationUser() { Email = x.Email, Id = x.Id }).ToList() };
                return View(roleToEdit);
            }
            return NotFound("Role not found!");
        }
        [HttpPost,Authorize(Policy = "DeleteRolePolicy")]
        public async Task<IActionResult> DeleteRole(string id)
        {
            var role = await roleManager.FindByIdAsync(id);
            if (role != null)
            {
                var result = await roleManager.DeleteAsync(role);
                if (result.Succeeded)
                {
                    return RedirectToAction("Roles");
                }
            }
            return NotFound("Role not found!");
        }
        [HttpPost, Authorize(Roles = "UpdateRolePolicy")]
        public async Task<IActionResult> UpdateRole(UpdateRoleVM model)
        {
            if (ModelState.IsValid)
            {
                var role = await roleManager.FindByIdAsync(model.RoleID);
                role.Name = model.RoleName;
                var result = await roleManager.UpdateAsync(role);

                if (result.Succeeded)
                {
                    return RedirectToAction("Roles");
                }
                foreach (var error in result.Errors)
                {
                    ModelState.AddModelError("", error.Description);
                }
            }
            return View(model);
        }

        public async Task<IActionResult> AddOrRemoveUsersInRole(string id)
        {
            ViewBag.RoleID = id;
            var role = await roleManager.FindByIdAsync(id);
            if(role == null)
            {
                return NotFound("Role not found!");
            }
            var users = userManager.Users;

            var model = new List<UserRoleVM>();
            foreach (var user in users)
            {
                var userRoleVM = new UserRoleVM() { 
                    UserID = user.Id,
                    Username = user.UserName
                };

                userRoleVM.IsSelected = await userManager.IsInRoleAsync(user, role.Name);
                model.Add(userRoleVM);
            }

            return View(model);
        }
        [HttpPost]
        public async Task<IActionResult> AddOrRemoveUsersInRole(string roleID, List<UserRoleVM> model)
        {
            var role = await roleManager.FindByIdAsync(roleID);
            if(role == null)
            {
                return NotFound("Role not found!");
            }

            IdentityResult result = null;
            for(int i = 0; i < model.Count; i++)
            {
                var user = await userManager.FindByIdAsync(model[i].UserID);
                if (model[i].IsSelected && !(await userManager.IsInRoleAsync(user,role.Name)))
                {
                    result = await userManager.AddToRoleAsync(user, role.Name);
                } 
                else if(!model[i].IsSelected && await userManager.IsInRoleAsync(user, role.Name))
                {
                    result = await userManager.RemoveFromRoleAsync(user, role.Name);
                }
                else
                {
                    continue;
                }

                if (result.Succeeded)
                {
                    if(i < (model.Count - 1))
                    {
                        continue;
                    }
                    else
                    {
                        return RedirectToAction("UpdateRole", new { Id = roleID });
                    }
                }
            }

            return RedirectToAction("UpdateRole", new { Id = roleID });
        }

        public async Task<IActionResult> Users()
        {
            var users = await userManager.Users.ToListAsync();
            return View(users);
        }

        public async Task<IActionResult> UpdateUser(string id)
        {
            var user = await userManager.FindByIdAsync(id);
            if(user == null)
            {
                return NotFound("User not found!");
            }

            var userClaims = await userManager.GetClaimsAsync(user);
            var userRoles = await userManager.GetRolesAsync(user);

            var model = new UpdateUserVM() {
                UserID = user.Id,
                Email = user.Email,
                Username = user.UserName,
                IsEmailConfirmed = user.EmailConfirmed,
                //Fullname = user.FullName,
                Claims = userClaims.Select(x => x.Value).ToList(),
                Roles = userRoles.Select(x => x).ToList()
            };



            return View(model);
        }
        [HttpPost]
        public async Task<IActionResult> UpdateUser(UpdateUserVM model)
        {
            if (ModelState.IsValid)
            {
                var user = await userManager.FindByIdAsync(model.UserID);
                if (user == null)
                {
                    return NotFound("User not found!");
                }


                user.UserName = model.Username;
                //user.FullName = model.Fullname;
                user.Email = model.Email;
                user.EmailConfirmed = model.IsEmailConfirmed;

                var result = await userManager.UpdateAsync(user);
                if (result.Succeeded)
                {
                    return RedirectToAction("Users");
                }
                foreach (var error in result.Errors)
                {
                    ModelState.AddModelError("", error.Description);
                }
            }

            return View(model);
        }

        [HttpPost]
        public async Task<IActionResult> DeleteUser(string id)
        {
            var user = await userManager.FindByIdAsync(id);
            if (user == null)
            {
                return NotFound("User not found!");
            }

            var result = await userManager.DeleteAsync(user);
            if (result.Succeeded)
            {
                return RedirectToAction("Users");
            }

            foreach (var error in result.Errors)
            {
                ModelState.AddModelError("", error.Description);
            }
            return View("Users");
        }

        public async Task<IActionResult> AddOrRemoveUserRoles(string id)
        {
            ViewBag.UserID = id;
            var user = await userManager.FindByIdAsync(id);
            if (user == null)
            {
                return NotFound("User not found!");
            }

            var model = new List<UserRolesVM>();

            foreach (var role in roleManager.Roles)
            {
                var userRolesVM = new UserRolesVM() { 
                    RoleID = role.Id,
                    RoleName = role.Name
                };

                userRolesVM.IsSelected = await userManager.IsInRoleAsync(user, role.Name);
                model.Add(userRolesVM);

            }

            return View(model);
        }
        public async Task<IActionResult> AddOrRemoveUserClaims(string id)
        {
            ViewBag.UserID = id;
            var user = await userManager.FindByIdAsync(id);
            if (user == null)
            {
                return NotFound("User not found!");
            }

            var existingUserClaims = await userManager.GetClaimsAsync(user);
            var model = new UserClaimsVM() { UserID = id };

            foreach (Claim claim in ClaimStore.AllClaims)
            {
                UserClaim userClaim = new UserClaim()
                {
                    ClaimType = claim.Type,
                    ClaimValue = claim.Value
                };

                if(existingUserClaims.Any(x=>x.Type == claim.Type))
                {
                    userClaim.IsSelected = true;
                }

                model.Claims.Add(userClaim);
            }

            return View(model);
        }

IdentityServer/Views/Shared/Redirect.cshtml
@model RedirectViewModel

<h1>You are now being returned to the application.</h1>
<p>Once complete, you may close this tab</p>

<meta http-equiv="refresh" content="0;url=@Model.RedirectUrl" data-url="@Model.RedirectUrl">
<script src="~/js/signin-redirect.js"></script>

IdentityServer/Views/Shared/_Layout.cshtml
@inject SignInManager<ApplicationUser> signInManager;

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Identity Server</title>
    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link href="~/font-awesome/css/all.css" rel="stylesheet" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" />
    </environment>
    <link rel="stylesheet" href="~/css/site.css" />


    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
        <script src="~/lib/jquery-validation/dist/jquery.validate.js"></script>
        <script src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-xrRywqdh3PHs8keKZN+8zzc5TX0GRTLCcmivcbNJWm2rs5C8PRhcEn3czEjhAO9o">
        </script>
    </environment>
    <script src="~/js/site.js" asp-append-version="true"></script>
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm  navbar-dark bg-dark border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">IdentityServer</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <partial name="_LoginPartial" />
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        @if (signInManager.IsSignedIn(User))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="Grants" asp-action="Index">Grants</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="Device" asp-action="Index">Device</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="Diagnostics" asp-action="Index">Diagnostics</a>
                            </li>
                            @if (User.IsInRole("Administrator"))
                            {
                                <li class="nav-item dropdown">
                                    <a class="nav-link dropdown-toggle text-white" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        Administration
                                    </a>
                                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                        <a class="dropdown-item" asp-area="" asp-controller="Administration" asp-action="Roles">Roles</a>
                                        <a class="dropdown-item" asp-area="" asp-controller="Administration" asp-action="Users">Users</a>
                                    </div>
                                </li>
                            }

                        }

                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container-fluid">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container-fluid bg-dark text-white">
            &copy; 2019 - IdentityServer - <a asp-area="" asp-controller="Home" asp-action="Privacy" class="text-white">Privacy</a>
        </div>
    </footer>

    @RenderSection("Scripts", required: false)
</body>
</html>

IdentityServer/Views/Shared/_ScopeListItem.cshtml
@model ScopeViewModel

<li class="list-group-item">
    <label>
        <input class="consent-scopecheck"
               type="checkbox"
               name="ScopesConsented"
               id="scopes_@Model.Name"
               value="@Model.Name"
               checked="@Model.Checked"
               disabled="@Model.Required" />
        @if (Model.Required)
        {
            <input type="hidden"
                   name="ScopesConsented"
                   value="@Model.Name" />
        }
        <strong>@Model.DisplayName</strong>
        @if (Model.Emphasize)
        {
            <span class="glyphicon glyphicon-exclamation-sign"></span>
        }
    </label>
    @if (Model.Required)
    {
        <span><em>(required)</em></span>
    }
    @if (Model.Description != null)
    {
        <div class="consent-description">
            <label for="scopes_@Model.Name">@Model.Description</label>
        </div>
    }
</li>

IdentityServer/Views/Shared/_ValidationSummary.cshtml
@if (ViewContext.ModelState.IsValid == false)
{
    <div class="alert alert-danger">
        <strong>Error</strong>
        <div asp-validation-summary="All" class="danger"></div>
    </div>
}